/////////////////////////////////////////////////////////////////
//Aufgabe 4  Kapitel Fraktale
//////////////////////////////////////////////////////////////

//Winkelzunahme alpha (im Bogenmass) pro Iteration
float alpha = 1.111;
//Bildausschnitt zu Beginn: 
//Zentrieren und entzerren mit :
float xU =-1; //-1
float xO = 3; // 1
float yU = -2; // -1
float yO = 2; //1
//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, sollte man mit double-Werten 
// rechnen
double dx ;
double dy ;
double xStart ;
double yStart ;
int nOrbits; // Anzahl Orbits mit unterschiedlichem Radius
int nPoints ; // Punkte pro Orbit
// Hilfsvariablen:
int punkteZaehler = 0;
double xH = xStart;
double yH = yStart; 
PImage fbereich;
///////////////////////////////////////////////////////////////////////////
//Initialisierungen  
///////////////////////////////////////////////////////////////////////////
void setup() { 
  size(800, 800);
  background(255);
  colorMode(HSB);
  dx = 0.001;
  dy = 0.001;//Startpunkte Änderung
  xStart = 0;
  yStart = 0;
  nOrbits = 1000; 
  nPoints = 4000; 
}
//////////////////////////////////////////////////////////
//Iteration
/////////////////////////////////////////////////////////
void iteriere(double xAlt,double yAlt) {  
  int i=0;
  stroke(color( punkteZaehler % 256, 255, 255));
  while (i <=nOrbits) {
    if (Math.abs(xAlt)< 100000 && Math.abs(yAlt)< 100000) {
      double xNeu = xAlt*cos(alpha)-(yAlt-xAlt*xAlt)*sin(alpha); 
      double yNeu = xAlt*sin(alpha)+(yAlt-xAlt*xAlt)*cos(alpha);   
      float xK = round(map((float)xNeu,(float) xU, (float)xO, 0, width));                 
      float yK = round(map((float)yNeu,(float) yU, (float)yO, height, 0));    
      point(xK, yK);  
      xAlt = xNeu;
      yAlt = yNeu;
    }
    i++;
  }
}
///////////////////////////////////////////////////////////////////////////
void draw() {
  //Fraktal zeichnen
  iteriere(xH,yH); 
  punkteZaehler++;
  xH = xH + dx; 
  yH = yH + dy;//nächster Startpunkt
  if (punkteZaehler>=nPoints) {
    println("alle Punkte gesetzt, fertig"); 
    noLoop();
  }
  if (abs((float)xH) >= 3 && abs((float)yH) >=2) {
    println("äussere Grenze erreicht, fertig");
    noLoop();
  }
}
///////////////////////////////////////////////////////////////////////////
//Fluchtbereich / Gefangenenbereich zeichnen
///////////////////////////////////////////////////////////////////////
PImage zeichne_Fluchtbereich() {
 PImage bild = createImage(width, height, ARGB);
  print("Berechne Fluchtbereich: ");
  for (int l = 0; l<width; l++) {
    for (int s =0; s<height; s++) {
      double xAlt = map(l, 0, width, xU, xO);
      double yAlt = map(s, 0, height, yO, yU);
      for (int k =0; k <= 100; k++) {
        double xNeu = xAlt*cos(alpha)-(yAlt-xAlt*xAlt)*sin(alpha); 
        double yNeu = xAlt*sin(alpha)+(yAlt-xAlt*xAlt)*cos(alpha); 
        xAlt = xNeu; 
        yAlt = yNeu;
      }
      double d = Math.sqrt(xAlt*xAlt + yAlt*yAlt);  
      if(d < 10000) bild.pixels[l+s*width] = color(0, 0, 0);//schwarz für Gefangenenbereich
         else bild.pixels[l+s*width] = color(0, 0, 255); //weiß für Fluchtbereich
    }
    if (l % 50 == 0) print(100*l/height + "% ");//Zur Kontrolle
  }
  xH = xStart; 
  yH = yStart;
  punkteZaehler = 0;
  return bild;
}
//////////////////////////////////////
void keyPressed() {  
  if (key == 'f') {
    if (fbereich==null) fbereich = zeichne_Fluchtbereich();
    image(fbereich, 0, 0);
    punkteZaehler=0;
  }  
  if (key == 'd') background(255);
  if (key == 's') save("image.png");
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(255);
  float xUNeu = map(mouseX, 0, width, xU, xO)-(xO-xU)/5;
  float xONeu = map(mouseX, 0, width, xU, xO)+(xO-xU)/5;
  float yUNeu = map(mouseY, 0, height, yO, yU)-(yO-yU)/5;
  float yONeu = map(mouseY, 0, height, yO, yU)+(yO-yU)/5;
  xU = xUNeu; 
  xO = xONeu; 
  yU = yUNeu; 
  yO = yONeu;
  xH = xStart; 
  yH = yStart;
  //dx = dx/2;
  //dy = dy/2; //falls in den Chaosbereich gezoomt werden soll
  nOrbits = nOrbits*3; 
  punkteZaehler = 0;
}